//---------------------------------------------------------------------------
// File: TMainForm.h, TDx_3DI_Library, Landscape
//
// Date: 13th January, 2004
// Author: Darren John Dwyer
// Copyright: (c) 2002-2004 Darren John Dwyer, All Rights Reserved.
//
// Description:
// This application shows how to create and use some of the features of
// Direct3D.
//
//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#ifndef D3D_OVERLOADS
#define D3D_OVERLOADS
#endif
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include "TDx_3DI_Library_Defns.H"
#include "TDx_3DI_Library_Functions.H"
#include "TD3DMatrix.h"
#include "TD3DViewPort.h"
#include "TDDBltFX.h"
#include "TDDPixelFormat.h"
#include "TDDSCaps.h"
#include "TDDSurfaceDesc.h"
#include "TDx_3D.h"
#include "TDx_3DDevice.h"
#include "TDx_Draw.h"
#include "TDx_DrawClipper.h"
#include "TDx_DrawSurface.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TDx_Draw *DirectDraw;
	TDx_DrawSurface *PrimarySurface;
	TDx_DrawSurface *BackBuffer;
	TDDSCaps *PrimarySurfaceCaps;
	TDDSurfaceDesc *PrimarySurfaceDesc;
	TDx_DrawClipper *PrimaryClipper;
	TGroupBox *GroupBox1;
	TBitBtn *ExitButton;
	TBitBtn *StartButton;
	TGroupBox *Stuff;
	TLabel *Direct3DI_Label;
	TLabel *DirectDraw_Label;
	TLabel *Direct3DIDevice_Label;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TDx_DrawSurface *Texture3D;
	TDDSurfaceDesc *TextureSurfaceDesc;
	TDDSCaps *TextureSurfaceCaps;
	TTimer *Timer1;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label9;
	TLabel *PrimarySurface_Label;
	TLabel *BackBuffer_Label;
	TLabel *CooperativeLevel_Label;
	TLabel *HardwareZBuffer_Label;
	TLabel *ViewPort3D_Label;
	TLabel *Texture3D_Label;
	TLabel *Label10;
	TLabel *Animating_Label;
	TLabel *Label0;
	TLabel *Label11;
	TLabel *Label12;
	TLabel *BeginScene_Label;
	TLabel *DrawPrimitive_Label;
	TLabel *EndScene_Label;
	TCheckBox *FullScreenCheckBox;
	TGroupBox *ErrorMessages;
	TMemo *ErrorMemo;
	TCheckBox *ShowStuffCheckBox;
	TDDPixelFormat *DDPixelFormat1;
	TLabel *Label13;
	TLabel *OffscreenSurface_Label;
	TLabel *Label14;
	TLabel *PrimaryClipper_Label;
	TCheckBox *ShowLinesCheckBox;
	TBitBtn *UpButton;
	TBitBtn *LtButton;
	TBitBtn *CenterButton;
	TBitBtn *RtButton;
	TBitBtn *DnButton;
	TDDBltFX *DDBltFX1;
	TLabel *Label15;
	TLabel *Label16;
	TBitBtn *ZoomInButton;
	TBitBtn *ZoomOutButton;
	void __fastcall StartButtonClick(TObject *Sender);
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall DirectDrawError(TObject *Sender, AnsiString Function,
	AnsiString Error, AnsiString ErrorMessage);







	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall ShowStuffCheckBoxClick(TObject *Sender);

	void __fastcall Direct3DIEnumZBufferFormats(TObject *Sender,
	TDDPixelFormat *DeviceDesc, void *Context, bool &Continue);




	void __fastcall CenterButtonClick(TObject *Sender);


	void __fastcall UpButtonMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall LtButtonMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall RtButtonMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall DnButtonMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall FormCreate(TObject *Sender);
	
	
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	
	
	
	void __fastcall ZoomInButtonMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall ZoomOutButtonMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
private:	// User declarations
	void __fastcall RenderScene();
    void __fastcall DisplayScene();
public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
